package ru.dbotthepony.mc.otm.datagen.lang

import ru.dbotthepony.mc.otm.registry.*

private fun decoratives(provider: MatteryLanguageProvider) {
	provider.englishColors.add(MRegistry.VENT, "%s Vent")
	provider.englishColors.add(MRegistry.VENT_ALTERNATIVE, "%s Alternative Vent")

	provider.englishColors.add(MRegistry.TRITANIUM_BLOCK, "%s Tritanium Block")
	provider.englishColors.add(MRegistry.FLOOR_TILES, "%s Floor Tiles")
	provider.englishColors.add(MRegistry.UNREFINED_FLOOR_TILES, "Unrefined %s Floor Tiles")

	provider.englishColors.add(MRegistry.INDUSTRIAL_GLASS, "%s Stained Industrial Glass")
	provider.englishColors.add(MRegistry.INDUSTRIAL_GLASS_PANE, "%s Stained Industrial Glass Pane")

	provider.englishColors.add(MRegistry.CARGO_CRATES, "%s Cargo Crate")
	provider.englishColors.add(MRegistry.DECORATIVE_CRATE, "%s Container Block")

	with(provider.english) {
		add(MRegistry.CARGO_CRATES.block, "Cargo Crate")
		add(MRegistry.TRITANIUM_BLOCK.block, "Tritanium Block")

		add(MRegistry.INDUSTRIAL_GLASS.block, "Industrial Glass")
		add(MRegistry.INDUSTRIAL_GLASS_PANE.block, "Industrial Glass Pane")

		add(MRegistry.DECORATIVE_CRATE.block, "Rusty Container Block")

		add(MRegistry.VENT.block, "Vent")
		add(MRegistry.VENT_ALTERNATIVE.block, "Alternative Vent")

		for ((block, colors) in MRegistry.TRITANIUM_STRIPED_BLOCK.blocksWithColor) {
			val (base, stripe) = colors

			val baseName = provider.englishColors.dyeClassMapped[base]!!
			val stripeName = provider.englishColors.dyeClassMapped[stripe]!!

			add(block, "$baseName Colored $stripeName Striped Tritanium Block")
		}
	}
}

private fun sounds(provider: MatteryLanguageProvider) {
	with(provider.english) {
		sound("rifle_shot", "Plasma rifle fires")
		sound("plasma_weapon_overheat", "Plasma weapon overheats")
		sound("player_become_android", "Player became android")

		sound(MSoundEvents.CARGO_CRATE_OPEN, "Cargo crate opened")
	}
}

private fun misc(provider: MatteryLanguageProvider) {
	with(provider.english) {
		gui("recipe.ticks", "%s Ticks")

		gui("exosuit", "Exosuit Inventory")
		gui("exosuit.go_back", "Open vanilla inventory")
		gui("exosuit.go_in", "Open ExoSuit inventory")

		gui("exosuit.probe1", "This little device feels unnatural to touch, it is almost certainly resilient to any possible attempt to break it open.")
		gui("exosuit.probe2", "There is fingerprint reader built into one of sides which gently glow when touched.")
		gui("exosuit.probe3", "It seems this box will unlock once you strongly press fingerprint reader, and you feel what's inside will affect you without any way back!")

		gui("exosuit.already_activated", "You already have Exosuit following you")

		gui("exosuit_upgrades.no_exosuit", "This piece of technology seems to be of no use to you.... Or is it?!")

		gui("exosuit_upgrades.already_activated", "Upgrade is already active!")
		gui("exosuit_upgrades.slots_upgrade", "Using this will permanently grant %s slots in Exosuit inventory.")
		gui("exosuit_upgrades.crafting_upgrade", "Using this will permanently grant 3x3 crafting grid in Exosuit inventory.")

		gui("crude_battery.replace_in_world", "Simplistic nature of this battery allows to replace your energy source in the field without using Android Station.")
		gui("crude_battery.replace_in_world_warning", "This operation is very unstable and causes serious damage to your systems!")

		gui("power_supplier.active_nodes", "Currently demanding nodes: %s")

		misc("battery.single_use", "Single use battery, can not be recharged.")

		misc("exosuit_upgrades.slots_upgraded", "Your Exosuit has permanently gained %s slots")
		misc("exosuit_upgrades.crafting_upgraded", "Your Exosuit has permanently gained 3x3 crafting grid")

		misc("exosuit.granted1", "As you keep pressing fingerprint reader, you are getting hurt in finger.")
		misc("exosuit.granted2", "After you raise your finger, fingerprint reader glows very bright.")
		misc("exosuit.granted3", "Then, fingerprint reader fades, leaving faint trace not of your finger, but of your very soul.")
		misc("exosuit.granted4", "The device opens... And whatever was inside it shroud you, yet you feel nothing, as it wasn't even there.")
		misc("exosuit.granted5", "As whatever shrouded you takes final form, you feel it binds to your soul.")
		misc("exosuit.granted6", "INITIALIZATION SEQUENCE COMPLETE. WELCOME, USER %s")
		misc("exosuit.granted7", "You are now permanently equipped with four dimensional omni-present Exosuit.")
		misc("exosuit.granted8", "As of now, this exosuit is not much, but it's built-in AI hints there are upgrade modules out there somewhere...")

		misc("iteration", "Iteration %s")
		misc("death_reason", "Decommissioned!")

		misc("item.blackhole_immunity", "Negates gravitational effects of singularities")

		misc("suffix.merge", "%s %s")

		misc("suffix.kilo", "%s k%s")
		misc("suffix.mega", "%s M%s")
		misc("suffix.giga", "%s G%s")
		misc("suffix.tera", "%s T%s")
		misc("suffix.peta", "%s P%s")
		misc("suffix.exa", "%s E%s")
		misc("suffix.zetta", "%s Z%s")
		misc("suffix.yotta", "%s Y%s")

		misc("suffix.deci", "%s d%s")
		misc("suffix.centi", "%s c%s")
		misc("suffix.milli", "%s m%s")
		misc("suffix.micro", "%s μ%s")
		misc("suffix.nano", "%s n%s")
		misc("suffix.pico", "%s p%s")
		misc("suffix.femto", "%s f%s")
		misc("suffix.atto", "%s a%s")
		misc("suffix.zepto", "%s z%s")
		misc("suffix.yocto", "%s y%s")

		misc("suffix_raw.kilo", "k")
		misc("suffix_raw.mega", "M")
		misc("suffix_raw.giga", "G")
		misc("suffix_raw.tera", "T")
		misc("suffix_raw.peta", "P")
		misc("suffix_raw.exa", "E")
		misc("suffix_raw.zetta", "Z")
		misc("suffix_raw.yotta", "Y")
		misc("suffix_raw.deci", "d")
		misc("suffix_raw.centi", "c")
		misc("suffix_raw.milli", "m")
		misc("suffix_raw.micro", "μ")
		misc("suffix_raw.nano", "n")
		misc("suffix_raw.pico", "p")
		misc("suffix_raw.femto", "f")
		misc("suffix_raw.atto", "a")
		misc("suffix_raw.zepto", "z")
		misc("suffix_raw.yocto", "y")

		misc("container.matter_panel.increase_by", "+%s")
		misc("container.matter_panel.decrease_by", "-%s")
		misc("container.matter_panel.send", "Send")
		misc("container.matter_panel.close", "Close")
		misc("container.matter_panel.cancel_task", "Cancel task")
		misc("container.matter_panel.cancel", "Cancel")
		misc("container.matter_panel.label", "Replication request")
		misc("container.matter_panel.task", "Ongoing replication task")
		misc("container.matter_panel.task_line", "%s: %s | %s / %s")

		misc("container.matter_panel.tasks", "Tasks")
		misc("container.matter_panel.patterns", "Patterns")

		misc("item.power.infinite.storage", "Stored energy: Infinity / Infinity")
		misc("item.power.infinite.throughput", "Max I/O Infinite / Infinite")
		misc("item.power.passed", "Passed energy: %s")
		misc("item.power.received", "Received energy: %s")
		misc("item.power.average", "Average throughput: %s/t")
		misc("item.power.last_20_ticks", "Last second: %s")
		misc("item.power.last_tick", "Last tick: %s")

		misc("item.power.storage", "Stored energy: %s / %s")
		misc("item.power.throughput", "Max throughput: %s / %s")
		misc("item.power.throughput_mono", "Max throughput: %s")
		misc("item.power.infinity", "Infinity MtJ")

		misc("item.worker.work_ticks_mono", "Work ticks: %s")
		misc("item.worker.work_ticks", "Work ticks: %s / %s")

		misc("item.block.stored_battery", "Battery: %s")

		misc("item.pattern.stored", "Stored patterns: %s / %s")
		misc("item.pattern.infinite.stored", "Stored patterns %s")
		misc("item.pattern.line", "%s [%s%%]")
		misc("item.pattern.research", "Researched: %s%%")

		misc("item.matter.infinite", "Stored matter: Infinity / Infinity")
		misc("item.matter.normal", "Stored matter: %s / %s")

		misc("gui.matter_task.total", "Total: %s")
		misc("gui.matter_task.required", "Left to be done: %s")
		misc("gui.matter_task.in_progress", "In progress: %s")
		misc("gui.matter_task.finished", "Finished: %s")

		misc("pill.warning", "WARNING: This will INSTANTLY decommission you upon ingestion!")
		misc("pill.android", "Take this pill and lose what is holding you back.")

		misc("pill.humane", "Take this pill and wake up in bed none the wiser.")

		misc("pill.oblivion", "Items and Experience spent on research is fully refunded.")
		misc("pill.message_oblivion", "All android features are removed and all research refunded.")

		misc("pill.heal", "Instantly restores 4 hearts upon ingestion, provides 2 min Absorption V and 8 seconds Regeneration III.")
		misc("pill.heal_android", "Does nothing to androids.")

		misc("pill.message", "Nothing happened, but you feel exhausted?.. Maybe get rest.")
		misc("pill.message_finish", "§kONE OF US ONE OF US ONE OF US ONE OF US ONE OF US")

		misc("gui.power.percentage_level", "Energy level: %s%%")
		misc("gui.level", "%s / %s")
		misc("gui.power.name", "MtJ")

		misc("gui.power.burn_time", "Burn time left: %s ticks")

		misc("gui.progress_widget", "Progress: %s%%")
		misc("gui.progress_widget_stuck", "The machine can not work, check configuration")

		misc("gui.total_raw", "Total:")

		misc("gui.matter.percentage_level", "Matter level: %s%%")
		misc("gui.matter.format", "Matter: %s")
		misc("gui.matter.format_and_complexity", "%s / Complexity: %s")
		misc("gui.matter.name", "MtU")

		misc("gui.filter.is_whitelist", "Is Whitelist")
		misc("gui.filter.match_nbt", "Match NBT")
		misc("gui.filter.match_tag", "Match Tag")

		misc("gui.android_research", "Research Tree")

		misc("gui.pattern.percentage_level", "Fill level: %s%%")
		misc("gui.pattern.format", "Stored patterns: %s / %s")

		misc("gui.redstone.ignored", "Redstone mode: Ignored")
		misc("gui.redstone.low", "Redstone mode: Low")
		misc("gui.redstone.high", "Redstone mode: High")

		misc("gui.redstone.ignored.description", "Redstone signal does not affect machine's function")
		misc("gui.redstone.low.description", "Machine work if no redstone signal is present")
		misc("gui.redstone.high.description", "Machine work only if any redstone signal is present")

		misc("3d2d.gravitation_stabilizer.mass", "Singularity mass: %s")
		misc("3d2d.gravitation_stabilizer.strength", "Gravitation strength: %s")

		misc("android_station.research.low_power", "Android Station is low on power! Can't research!")
		misc("android_station.research.researched", "Researched!")
		misc("android_station.research.can_be_researched", "Ready to research!")
		misc("android_station.research.can_not_be_researched", "Can't research!")
		misc("android_station.research.xp_cost", "Experience cost: %s levels")
		misc("android_station.research.item", "Requires %s x%s")
		misc("android_station.research.missing_predecessors", "%s needs to be researched first")

		misc("android_station.low_power_0", "Not enough power; Can't swap parts")
		misc("android_station.low_power_1", "Low power; Can't research")
		misc("android_station.power_ok", "Power OK")

		misc("filter.yes", "Yes")
		misc("filter.no", "No")

		misc("matter_bottler.switch_mode", "Switch work mode")

		misc("container.matter_panel.number_input", "Input replication task count")

		misc("item.quantum_battery.creative", "Fill this to win Minecraft.")
		misc("item.quantum_battery.creative2", "See ya after millions of stars burn out.")
		misc("item.quantum_battery.creative_power", "Stored energy: %s / Infinity")

		misc("item.quantum_link_id", "Quantum link ID: %s")
		misc("item.quantum_description", "This item is sharing it's contents with other similar items using quantum entanglement")
	}
}

private fun death(provider: MatteryLanguageProvider) {
	with(provider.english) {
		death("otm_become_android", "%1\$s lost their humanity")
		death("otm_become_humane", "%1\$s regained their humanity")
		death("otm_event_horizon", "%1\$s never crossed event horizon")
		death("otm_hawking_radiation", "%1\$s discovered Hawking radiation")
		death("otm_emp", "%1\$s electronics' fried")

		death("otm_become_android.player", "%1\$s lost their humanity whilst %2\$s tried to reason with them")
		death("otm_become_humane.player", "%1\$s gained their humanity whilst %2\$s tried to reason with them")
		death("otm_event_horizon.player", "%1\$s tried to cross event horizon whilst trying to escape %2\$s")
		death("otm_hawking_radiation.player", "%1\$s disintegrated whilst fighting %2\$s")
		death("otm_emp.player", "%1\$s blew fuzes of %2\$s")
		death("otm_emp.player.item", "%1\$s blew fuzes of %2\$s using %3\$s")

		death(MRegistry.DAMAGE_EXOSUIT_PROBE_ID, "%1\$s hit little finger against cupboard")
		death("${MRegistry.DAMAGE_EXOSUIT_PROBE_ID}.player", "%1\$s hit little finger against cupboard whilst %2\$s tried to finish them off")
	}
}

private fun blocks(provider: MatteryLanguageProvider) {
	with(provider.english) {
		add(MBlocks.ANDROID_STATION, "Android Station")
		add(MBlocks.BATTERY_BANK, "Battery Bank")
		add(MBlocks.MATTER_DECOMPOSER, "Matter Decomposer")
		add(MBlocks.MATTER_CAPACITOR_BANK, "Matter Capacitor Bank")
		add(MBlocks.MATTER_CABLE, "Matter Network Cable")
		add(MBlocks.PATTERN_STORAGE, "Pattern Storage")
		add(MBlocks.MATTER_SCANNER, "Matter Scanner")
		add(MBlocks.MATTER_PANEL, "Pattern Monitor")
		add(MBlocks.MATTER_REPLICATOR, "Matter Replicator")
		add(MBlocks.MATTER_BOTTLER, "Matter Bottler")
		add(MBlocks.DRIVE_VIEWER, "Drive Viewer")
		add(MBlocks.BLACK_HOLE, "Local Anomalous Singular Gravitation Field")

		add(MBlocks.ENERGY_COUNTER, "Energy Counter")
		add(MBlocks.ENERGY_COUNTER, "facing", "Input facing: %s")
		add(MBlocks.ENERGY_COUNTER, "switch", "Switch input facing")
		add(MBlocks.ENERGY_COUNTER, "limit", "I/O Limit. -1 means no limit")

		add(MBlocks.CHEMICAL_GENERATOR, "Chemical Generator")
		add(MBlocks.DRIVE_RACK, "Condensation Drive Rack")
		add(MBlocks.ITEM_MONITOR, "Item Monitor")
		add(MBlocks.PLATE_PRESS, "Plate Press")

		add(MBlocks.MATTER_RECYCLER, "Matter Recycler")

		add(MBlocks.CARBON_FIBRE_BLOCK, "Carbon fibre Block")

		add(MBlocks.TRITANIUM_STRIPED_BLOCK, "Tritanium Striped Block")
		add(MBlocks.TRITANIUM_ORE, "Tritanium Ore")
		add(MBlocks.DEEPSLATE_TRITANIUM_ORE, "Deepslate Tritanium Ore")
		add(MBlocks.TRITANIUM_RAW_BLOCK, "Raw Tritanium Block")

		add(MBlocks.STORAGE_CABLE, "Storage Cable")
		add(MBlocks.STORAGE_POWER_SUPPLIER, "Storage Power Supplier")
		add(MBlocks.STORAGE_BUS, "Storage Bus")
		add(MBlocks.STORAGE_IMPORTER, "Storage Importer")
		add(MBlocks.STORAGE_EXPORTER, "Storage Exporter")

		add(MBlocks.GRAVITATION_STABILIZER, "Gravitation Stabilizer")
		add(MBlocks.GRAVITATION_STABILIZER_LENS, "Gravitation Stabilizer Lens")
		add(MBlocks.GRAVITATION_STABILIZER, "desc", "Reduces gravitation effects of singularities")
		add(MBlocks.GRAVITATION_STABILIZER, "desc2", "Requires no power to operate")
		add(MBlocks.GRAVITATION_STABILIZER, "desc3", "Keep in mind the effect of multiple stabilizers produce exponentially increasing result")
		add(MBlocks.GRAVITATION_STABILIZER, "desc4", "Too weak gravitation field will cause singularity to melt and evaporate away very fast")

		add(MBlocks.LABORATORY_LAMP, "Laboratory Lamp")
		add(MBlocks.LABORATORY_LAMP_INVERTED, "Laboratory Lamp (Inverted Signal)")
		add(MBlocks.DANGER_STRIPE_BLOCK, "Danger Stripes")
		add(MBlocks.METAL_BEAM, "Metal Beam")
	}
}

private fun items(provider: MatteryLanguageProvider) {
	with(provider.english) {
		add(MItems.EXOSUIT_PROBE, "Exosuit Probe")
		add(MItems.EXOSUIT_INVENTORY_UPGRADE_CREATIVE, "Creative Exosuit Inventory Upgrade")
		add(MItems.EXOSUIT_CRAFTING_UPGRADE, "Exosuit Crafting Upgrade")

		add(MItems.NUTRIENT_PASTE, "Nutrient paste")

		add(MItems.BLACK_HOLE_SCANNER, "Singularity Scanner")
		add(MItems.BLACK_HOLE_SCANNER, "desc", "Scans singularities for their properties")
		add(MItems.BLACK_HOLE_SCANNER, "desc2", "Hold in hand to determine mass of singularities")

		add(MItems.GRAVITATION_FIELD_LIMITER, "Gravitation Field Limiter")
		add(MItems.GRAVITATION_FIELD_SENSOR, "Gravitation Field Sensor")
		add(MItems.PORTABLE_GRAVITATION_STABILIZER, "Portable Gravitation Stabilizer")

		add(MItems.BATTERY_CRUDE, "Crude Battery")
		add(MItems.BATTERY_BASIC, "Basic Battery")
		add(MItems.BATTERY_NORMAL, "Ordinary Battery")
		add(MItems.BATTERY_DENSE, "Dense Battery")
		add(MItems.BATTERY_CAPACITOR, "Capacitor Battery")
		add(MItems.BATTERY_CREATIVE, "Creative Battery")

		add(MItems.QUANTUM_BATTERY, "Quantum Battery")
		add(MItems.QUANTUM_CAPACITOR, "Quantum Capacitor")
		add(MItems.QUANTUM_BATTERY_CREATIVE, "Quantum Creative Battery")

		add(MItems.TRITANIUM_SWORD, "Tritanium Sword")
		add(MItems.TRITANIUM_PICKAXE, "Tritanium Pickaxe")
		add(MItems.TRITANIUM_SHOVEL, "Tritanium Shovel")
		add(MItems.TRITANIUM_AXE, "Tritanium Axe")
		add(MItems.TRITANIUM_HOE, "Tritanium Hoe")

		add(MItems.TRITANIUM_HELMET, "Tritanium Helmet")
		add(MItems.TRITANIUM_CHESTPLATE, "Tritanium Chestplate")
		add(MItems.TRITANIUM_PANTS, "Tritanium Leggings")
		add(MItems.TRITANIUM_BOOTS, "Tritanium Boots")

		add(MItems.TRITANIUM_INGOT, "Tritanium Ingot")
		add(MItems.MATTER_IO_PORT, "Matter IO Port")
		add(MItems.MATTER_TRANSFORM_MATRIX, "Matter Transformation Matrix")
		add(MItems.ENERGY_BUS, "Energy Bus")
		add(MItems.ELECTRIC_PARTS,  "Electric Parts")
		add(MItems.MACHINE_FRAME, "Machine Frame")
		add(MItems.TRITANIUM_PLATE,  "Tritanium Plate")
		add(MItems.IRON_PLATE, "Iron Plate")
		add(MItems.COPPER_WIRING,  "Copper Wiring")
		add(MItems.GOLD_WIRING, "Gold Wiring")
		add(MItems.PORTABLE_CONDENSATION_DRIVE_CASING, "Portable Condensation Drive Casing")
		add(MItems.PORTABLE_DENSE_CONDENSATION_DRIVE_CASING, "Portable Dense Condensation Drive Casing")
		add(MItems.CIRCUIT_PLATING, "Circuit Plating")
		add(MItems.BASIC_CONTROL_CIRCUIT, "Basic Control Circuit")
		add(MItems.ADVANCED_CONTROL_CIRCUIT, "Advanced Control Circuit")

		add(MItems.GRAVITATIONAL_DISRUPTOR, "Gravitational Disruptor")

		add(MItems.GRAVITATIONAL_DISRUPTOR, "description", "Once within close proximity of supermassive body, suppresses any gravity in it's radius")
		add(MItems.GRAVITATIONAL_DISRUPTOR, "description2", "Allows collapse of black holes")
		add(MItems.GRAVITATIONAL_DISRUPTOR, "description3", "Doesn't destroy any of mass singularity had acquired, which result in violent explosion of matter!")
		add(MItems.GRAVITATIONAL_DISRUPTOR, "description4", "The explosion %s be contained by %s. Do not even attempt to contain it.")
		add(MItems.GRAVITATIONAL_DISRUPTOR, "description4_clarification", "can not")
		add(MItems.GRAVITATIONAL_DISRUPTOR, "description4_clarification2", "anything")

		add(MItems.MATTER_DUST, "Matter Dust")
		add(MItems.MATTER_DUST, "desc", "This item is product of failed decomposition or replication attempt")
		add(MItems.MATTER_DUST, "desc2", "Throw into matter recycler to get some of it's value back!")
		add(MItems.MATTER_DUST, "desc3", "Do not smell, throw at strangers or pour on donuts")

		add(MItems.PILL_ANDROID, "Android Pill")
		add(MItems.PILL_HUMANE, "Humane Pill")
		add(MItems.PILL_OBLIVION, "Android Factory Reset Pill")
		add(MItems.PILL_HEAL, "Medical Pill")

		add(MItems.MATTER_CAPACITOR_PARTS, "Matter Capacitor Parts")
		add(MItems.MATTER_CAPACITOR_BASIC, "Basic Matter Capacitor")
		add(MItems.MATTER_CAPACITOR_NORMAL, "Matter Capacitor")
		add(MItems.MATTER_CAPACITOR_DENSE, "Dense Matter Capacitor")
		add(MItems.MATTER_CAPACITOR_CREATIVE, "Creative Matter Capacitor")

		add(MItems.ENERGY_SWORD, "Powered Cake Slicer")
		add(MItems.ENERGY_SWORD, "desc", "Needs power to operate")
		add(MItems.ENERGY_SWORD, "desc2", "Deals extra damage to androids when powered")

		add(MItems.PORTABLE_CONDENSATION_DRIVE, "Portable Condensation Drive")
		add(MItems.PORTABLE_DENSE_CONDENSATION_DRIVE, "Portable Dense Condensation Drive")
		add(MItems.PLASMA_RIFLE, "Plasma Rifle")
		add(MItems.TRITANIUM_ORE_CLUMP, "Raw Tritanium")
		add(MItems.PATTERN_DRIVE_NORMAL, "Pattern Drive")
		add(MItems.PATTERN_DRIVE_CREATIVE, "Creative Pattern Drive")

		add(MItems.PATTERN_DRIVE_CREATIVE2, "Omni-Present Pattern Drive")
		add(MItems.PATTERN_DRIVE_CREATIVE2, "description1", "Creative-only item")
		add(MItems.PATTERN_DRIVE_CREATIVE2, "description2", "Holds pattern for every item that have matter value")

		add(MItems.ZPM_BATTERY, "Zero Point Module")
		add(MItems.ZPM_BATTERY, "description", "Can be found in hands of those who travel between dimensions, if they ever reached different reality of origin of these constructs...")
	}
}

private fun stats(provider: MatteryLanguageProvider) {
	with(provider.english) {
		stat("health_regenerated", "Damage Regenerated by Nanobots")
		stat("damage_absorbed", "Damage Absorbed by Nanobots")
		stat("power_consumed", "MtJ Burnt as Android")
	}
}

private fun research(provider: MatteryLanguageProvider) {
	with(provider.english) {
		add("android_research.status.requires", "Requires %s to be researched")
		add("android_research.status.blocks", "Locks %s")
		add("android_research.status.blocked_by", "Locked by %s")

		add(AndroidResearch.LIMB_OVERCLOCKING[0], "Limb Overclocking %s")
		add(AndroidResearch.LIMB_OVERCLOCKING[0], "description", "Boosts unit's mobility by %s%% and attack speed by %s%%")

		add(AndroidResearch.AIR_BAGS, "Air Bags")
		add(AndroidResearch.NANOBOTS, "Nanobots")
		add(AndroidResearch.AIR_BAGS, "description", "Allows unit to swim in water")
		add(AndroidResearch.NANOBOTS, "description", "Various useful nanobots for doing various tasks")

		add(AndroidResearch.NANOBOTS_REGENERATION[0], "Regeneration %s")
		add(AndroidResearch.NANOBOTS_REGENERATION[0], "description", "Nanobots get ability to repair unit's internal systems on the move")
		add(AndroidResearch.NANOBOTS_REGENERATION[0], "description_improve", "Improves regeneration speed")

		add(AndroidResearch.NANOBOTS_ARMOR, "Nanobots Armor")
		add(AndroidResearch.NANOBOTS_ARMOR, "description", "Allows nanobots to align themselves in cell shape, reducing incoming damage by a %% by absorbing impacts")

		add(AndroidResearch.NANOBOTS_ARMOR_SPEED[0], "Nanobots Armor Build Speed %s")
		add(AndroidResearch.NANOBOTS_ARMOR_SPEED[0], "description", "Reduces time required for nanobots to form protection layer")

		add(AndroidResearch.NANOBOTS_ARMOR_STRENGTH[0], "Nanobots Armor Strength %s")
		add(AndroidResearch.NANOBOTS_ARMOR_STRENGTH[0], "description", "Increases impact absorption strength of nanobots")

		add(AndroidResearch.EXTENDED_REACH, "Extended Reach")
		add(AndroidResearch.EXTENDED_REACH, "description", "Increases block interaction distance")

		add(AndroidResearch.IMPROVED_LIMBS, "Improved Limbs")
		add(AndroidResearch.IMPROVED_LIMBS, "description", "Allows limbs to be upgraded")

		add(AndroidResearch.STEP_ASSIST, "Step Assist")
		add(AndroidResearch.STEP_ASSIST, "description", "Allows unit to step up whole blocks")

		add(AndroidResearch.ATTACK_BOOST[0], "Improved Arms Servo %s")
		add(AndroidResearch.ATTACK_BOOST[0], "description", "Increases total melee attack strength by %s%%")
	}
}

private fun androidFeatures(provider: MatteryLanguageProvider) {
	with(provider.english) {
		add(AndroidFeatures.AIR_BAGS, "Air Bags")
	}
}

private fun gui(provider: MatteryLanguageProvider) {
	with(provider.english) {
		gui("item_monitor.refill_source.desc", "Controls from where to take items for slot auto refill")
		gui("item_monitor.refill_source.system", "System only. Crafting grid will be auto refilled only from storage system. This is the behavior you see in AE2 and Refined Storage")
		gui("item_monitor.refill_source.inventory", "Inventory only. Crafting grid will be auto refilled only from player's inventory")
		gui("item_monitor.refill_source.system_first", "System first. Crafting grid will be auto refilled from storage system, or from player's inventory if system has no appropriate item")
		gui("item_monitor.refill_source.inventory_first", "Inventory first. Crafting grid will be auto refilled from player's inventory, or from storage system if inventory has no appropriate item")
		gui("item_monitor.refill_source.do_not", "Do not auto refill")

		gui("item_monitor.result_target.desc", "Controls behavior of crafting")
		gui("item_monitor.result_target.all_system", "All system. Both crafting remainder and crafting result go to storage system")
		gui("item_monitor.result_target.mixed", "Mixed. Crafting result goes to player's inventory, remainder goes to storage system")
		gui("item_monitor.result_target.all_inventory", "All inventory. Both crafting remainder and crafting result go to player's inventory")

		gui("item_monitor.amount.desc", "Controls how much items to craft when quickcrafting")
		gui("item_monitor.amount.one", "Exactly one item")
		gui("item_monitor.amount.stack", "Exactly one stack. This is the behavior you see in AE2 and Refined Storage")
		gui("item_monitor.amount.full", "Stack of ingredients. Craft until reaching stack size of one of ingredients. If at least one of inputs is not stackable then 'one stack' mode is used instead")

		gui("stored_amount", "Exact amount stored: %s")
	}
}

fun AddEnglishLanguage(provider: MatteryLanguageProvider) {
	decoratives(provider)
	sounds(provider)
	misc(provider)
	death(provider)

	blocks(provider)
	items(provider)
	stats(provider)

	androidFeatures(provider)
	research(provider)
	gui(provider)

	with(provider.english) {
		add("itemGroup.otm", "Overdrive That Matters")
		add("itemGroup.otm_decorative", "Overdrive That Matters Decorative")
	}
}
